"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ResidualReactElementSerializer = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (c) 2017-present, Facebook, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _realm = require("../realm.js");

var _ResidualHeapSerializer = require("./ResidualHeapSerializer.js");

var _hoisting = require("../react/hoisting.js");

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _index = require("../values/index.js");

var _jsx = require("../react/jsx.js");

var _logger = require("../utils/logger.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

var _errors = require("../errors");

var _utils = require("../react/utils.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ResidualReactElementSerializer = exports.ResidualReactElementSerializer = function () {
  function ResidualReactElementSerializer(realm, residualHeapSerializer) {
    _classCallCheck(this, ResidualReactElementSerializer);

    this.realm = realm;
    this.residualHeapSerializer = residualHeapSerializer;
    this.logger = residualHeapSerializer.logger;
    this.reactOutput = realm.react.output || "create-element";
    this._lazilyHoistedNodes = undefined;
  }

  _createClass(ResidualReactElementSerializer, [{
    key: "_createReactElement",
    value: function _createReactElement(value) {
      return { attributes: [], children: [], declared: false, type: undefined, value: value };
    }
  }, {
    key: "_createReactElementAttribute",
    value: function _createReactElementAttribute() {
      return { expr: undefined, key: undefined, type: "PENDING" };
    }
  }, {
    key: "_createReactElementChild",
    value: function _createReactElementChild() {
      return { expr: undefined, type: "PENDING" };
    }
  }, {
    key: "_emitHoistedReactElement",
    value: function _emitHoistedReactElement(id, reactElement, hoistedCreateElementIdentifier, originalCreateElementIdentifier) {
      // if the currentHoistedReactElements is not defined, we create it an emit the function call
      // this should only occur once per additional function
      if (this._lazilyHoistedNodes === undefined) {
        var funcId = t.identifier(this.residualHeapSerializer.functionNameGenerator.generate());
        this._lazilyHoistedNodes = {
          id: funcId,
          createElementIdentifier: hoistedCreateElementIdentifier,
          nodes: []
        };
        var statement = t.expressionStatement(t.logicalExpression("&&", t.binaryExpression("===", id, t.unaryExpression("void", t.numericLiteral(0), true)),
        // pass the createElementIdentifier if it's not null
        t.callExpression(funcId, originalCreateElementIdentifier ? [originalCreateElementIdentifier] : [])));
        this.residualHeapSerializer.emitter.emit(statement);
      }
      // we then push the reactElement and its id into our list of elements to process after
      // the current additional function has serialzied
      (0, _invariant2.default)(this._lazilyHoistedNodes !== undefined);
      (0, _invariant2.default)(Array.isArray(this._lazilyHoistedNodes.nodes));
      this._lazilyHoistedNodes.nodes.push({ id: id, astNode: reactElement });
    }
  }, {
    key: "_getReactLibraryValue",
    value: function _getReactLibraryValue() {
      var reactLibraryObject = this.realm.fbLibraries.react;
      // if there is no React library, then we should throw and error
      if (reactLibraryObject === undefined) {
        throw new _errors.FatalError("unable to find React library reference in scope");
      }
      return reactLibraryObject;
    }
  }, {
    key: "_getReactCreateElementValue",
    value: function _getReactCreateElementValue() {
      var reactLibraryObject = this._getReactLibraryValue();
      return (0, _utils.getProperty)(this.realm, reactLibraryObject, "createElement");
    }
  }, {
    key: "_emitReactElement",
    value: function _emitReactElement(reactElement) {
      var _this = this;

      var value = reactElement.value;

      var shouldHoist = this.residualHeapSerializer.isReferencedOnlyByAdditionalFunction(value) !== undefined && (0, _hoisting.canHoistReactElement)(this.realm, value);

      var id = this.residualHeapSerializer.getSerializeObjectIdentifier(value);
      // this identifier is used as the deafult, but also passed to the hoisted factory function
      var originalCreateElementIdentifier = null;
      // this name is used when hoisting, and is passed into the factory function, rather than the original
      var hoistedCreateElementIdentifier = null;
      var reactElementAstNode = void 0;

      this.residualHeapSerializer.emitter.emitNowOrAfterWaitingForDependencies([value], function () {
        if (_this.reactOutput === "jsx") {
          reactElementAstNode = _this._serializeReactElementToJSXElement(value, reactElement);
        } else if (_this.reactOutput === "create-element") {
          var createElement = _this._getReactCreateElementValue();
          originalCreateElementIdentifier = _this.residualHeapSerializer.serializeValue(createElement);

          if (shouldHoist) {
            // if we haven't created a _lazilyHoistedNodes before, then this is the first time
            // so we only create the hoisted identifier once
            if (_this._lazilyHoistedNodes === undefined) {
              // create a new unique instance
              hoistedCreateElementIdentifier = t.identifier(_this.residualHeapSerializer.intrinsicNameGenerator.generate());
            } else {
              hoistedCreateElementIdentifier = _this._lazilyHoistedNodes.createElementIdentifier;
            }
          }

          var createElementIdentifier = shouldHoist ? hoistedCreateElementIdentifier : originalCreateElementIdentifier;
          reactElementAstNode = _this._serializeReactElementToCreateElement(value, reactElement, createElementIdentifier);
        } else {
          (0, _invariant2.default)(false, "Unknown reactOutput specified");
        }
        // if we are hoisting this React element, put the assignment in the body
        // also ensure we are in an additional function
        if (shouldHoist) {
          _this._emitHoistedReactElement(id, reactElementAstNode, hoistedCreateElementIdentifier, originalCreateElementIdentifier);
        } else {
          if (reactElement.declared) {
            _this.residualHeapSerializer.emitter.emit(t.expressionStatement(t.assignmentExpression("=", id, reactElementAstNode)));
          } else {
            reactElement.declared = true;
            _this.residualHeapSerializer.emitter.emit(t.variableDeclaration("var", [t.variableDeclarator(id, reactElementAstNode)]));
          }
        }
      });
      return id;
    }
  }, {
    key: "_serializeNowOrAfterWaitingForDependencies",
    value: function _serializeNowOrAfterWaitingForDependencies(value, reactElement, func) {
      var _this2 = this;

      var shouldSerialize = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

      var reason = this.residualHeapSerializer.emitter.getReasonToWaitForDependencies(value);

      var serialize = function serialize() {
        func();
      };

      if (reason) {
        this.residualHeapSerializer.emitter.emitAfterWaiting(reason, [value], function () {
          serialize();
          _this2._emitReactElement(reactElement);
        });
      } else {
        serialize();
      }
    }
  }, {
    key: "_serializeReactFragmentType",
    value: function _serializeReactFragmentType(typeValue) {
      var reactLibraryObject = this._getReactLibraryValue();
      // we want to vist the Symbol type, but we don't want to serialize it
      // as this is a React internal
      this.residualHeapSerializer.serializedValues.add(typeValue);
      (0, _invariant2.default)(typeValue.$Description instanceof _index.StringValue);
      this.residualHeapSerializer.serializedValues.add(typeValue.$Description);
      return t.memberExpression(this.residualHeapSerializer.serializeValue(reactLibraryObject), t.identifier("Fragment"));
    }
  }, {
    key: "_serializeReactElementType",
    value: function _serializeReactElementType(reactElement) {
      var _this3 = this;

      var value = reactElement.value;

      var typeValue = (0, _utils.getProperty)(this.realm, value, "type");

      this._serializeNowOrAfterWaitingForDependencies(typeValue, reactElement, function () {
        var expr = void 0;

        if (typeValue instanceof _index.SymbolValue && typeValue === (0, _utils.getReactSymbol)("react.fragment", _this3.realm)) {
          expr = _this3._serializeReactFragmentType(typeValue);
        } else {
          expr = _this3.residualHeapSerializer.serializeValue(typeValue);
        }
        reactElement.type = expr;
      });
    }
  }, {
    key: "_serializeReactElementAttributes",
    value: function _serializeReactElementAttributes(reactElement) {
      var _this4 = this;

      var value = reactElement.value;

      var keyValue = (0, _utils.getProperty)(this.realm, value, "key");
      var refValue = (0, _utils.getProperty)(this.realm, value, "ref");
      var propsValue = (0, _utils.getProperty)(this.realm, value, "props");

      if (keyValue !== this.realm.intrinsics.null) {
        var reactElementKey = this._createReactElementAttribute();
        this._serializeNowOrAfterWaitingForDependencies(keyValue, reactElement, function () {
          var expr = _this4.residualHeapSerializer.serializeValue(keyValue);
          reactElementKey.expr = expr;
          reactElementKey.key = "key";
          reactElementKey.type = "PROPERTY";
        });
        reactElement.attributes.push(reactElementKey);
      }

      if (refValue !== this.realm.intrinsics.null) {
        var reactElementRef = this._createReactElementAttribute();
        this._serializeNowOrAfterWaitingForDependencies(refValue, reactElement, function () {
          var expr = _this4.residualHeapSerializer.serializeValue(refValue);
          reactElementRef.expr = expr;
          reactElementRef.key = "ref";
          reactElementRef.type = "PROPERTY";
        });
        reactElement.attributes.push(reactElementRef);
      }

      var assignPropsAsASpreadProp = function assignPropsAsASpreadProp() {
        var reactElementSpread = _this4._createReactElementAttribute();
        _this4._serializeNowOrAfterWaitingForDependencies(propsValue, reactElement, function () {
          var expr = _this4.residualHeapSerializer.serializeValue(propsValue);
          reactElementSpread.expr = expr;
          reactElementSpread.type = "SPREAD";
        });
        reactElement.attributes.push(reactElementSpread);
      };

      // handle props
      if (propsValue instanceof _index.AbstractValue) {
        assignPropsAsASpreadProp();
      } else if (propsValue instanceof _index.ObjectValue) {
        if (propsValue.isPartialObject()) {
          assignPropsAsASpreadProp();
        } else {
          this.residualHeapSerializer.serializedValues.add(propsValue);

          var _loop = function _loop(propName, binding) {
            if (binding.descriptor !== undefined && propName !== "children") {
              (0, _invariant2.default)(propName !== "key" && propName !== "ref", "\"" + propName + "\" is a reserved prop name");
              var propValue = (0, _utils.getProperty)(_this4.realm, propsValue, propName);
              var reactElementAttribute = _this4._createReactElementAttribute();

              _this4._serializeNowOrAfterWaitingForDependencies(propValue, reactElement, function () {
                var expr = _this4.residualHeapSerializer.serializeValue(propValue);
                reactElementAttribute.expr = expr;
                reactElementAttribute.key = propName;
                reactElementAttribute.type = "PROPERTY";
              });
              reactElement.attributes.push(reactElementAttribute);
            }
          };

          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = propsValue.properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var _ref = _step.value;

              var _ref2 = _slicedToArray(_ref, 2);

              var propName = _ref2[0];
              var binding = _ref2[1];

              _loop(propName, binding);
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        }
      }
    }
  }, {
    key: "_serializeReactElementChildren",
    value: function _serializeReactElementChildren(reactElement) {
      var value = reactElement.value;

      var propsValue = (0, _utils.getProperty)(this.realm, value, "props");
      if (!(propsValue instanceof _index.ObjectValue)) {
        return;
      }
      // handle children
      if (propsValue.properties.has("children")) {
        var childrenValue = (0, _utils.getProperty)(this.realm, propsValue, "children");
        this.residualHeapSerializer.serializedValues.add(childrenValue);

        if (childrenValue !== this.realm.intrinsics.undefined && childrenValue !== this.realm.intrinsics.null) {
          if (childrenValue instanceof _index.ArrayValue) {
            var childrenLength = (0, _utils.getProperty)(this.realm, childrenValue, "length");
            var childrenLengthValue = 0;
            if (childrenLength instanceof _index.NumberValue) {
              childrenLengthValue = childrenLength.value;
              for (var i = 0; i < childrenLengthValue; i++) {
                var child = (0, _utils.getProperty)(this.realm, childrenValue, "" + i);
                if (child instanceof _index.Value) {
                  reactElement.children.push(this._serializeReactElementChild(child, reactElement));
                } else {
                  this.logger.logError(value, "ReactElement \"props.children[" + i + "]\" failed to serialize due to a non-value");
                }
              }
            }
          } else {
            reactElement.children.push(this._serializeReactElementChild(childrenValue, reactElement));
          }
        }
      }
    }
  }, {
    key: "serializeReactElement",
    value: function serializeReactElement(val) {
      var reactElement = this._createReactElement(val);

      this._serializeReactElementType(reactElement);
      this._serializeReactElementAttributes(reactElement);
      this._serializeReactElementChildren(reactElement);

      return this._emitReactElement(reactElement);
    }
  }, {
    key: "_addSerializedValueToJSXAttriutes",
    value: function _addSerializedValueToJSXAttriutes(prop, expr, attributes) {
      if (prop === null) {
        attributes.push(t.jSXSpreadAttribute(expr));
      } else {
        attributes.push((0, _jsx.convertKeyValueToJSXAttribute)(prop, expr));
      }
    }
  }, {
    key: "_serializeReactElementToCreateElement",
    value: function _serializeReactElementToCreateElement(val, reactElement, createElementIdentifier) {
      var type = reactElement.type,
          attributes = reactElement.attributes,
          children = reactElement.children;


      var createElementArguments = [type];
      // check if we need to add attributes
      if (attributes.length !== 0) {
        var astAttributes = [];
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = attributes[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var attribute = _step2.value;

            var _expr = attribute.expr;

            if (attribute.type === "SPREAD") {
              astAttributes.push(t.spreadProperty(_expr));
            } else if (attribute.type === "PROPERTY") {
              var attributeKey = attribute.key;
              var _key = void 0;

              (0, _invariant2.default)(typeof attributeKey === "string");
              if (attributeKey.includes("-")) {
                _key = t.stringLiteral(attributeKey);
              } else {
                _key = t.identifier(attributeKey);
              }
              astAttributes.push(t.objectProperty(_key, _expr));
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        createElementArguments.push(t.objectExpression(astAttributes));
      }
      if (children.length !== 0) {
        if (attributes.length === 0) {
          createElementArguments.push(t.nullLiteral());
        }
        var astChildren = [];
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = children[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var child = _step3.value;

            var _expr2 = child.expr;

            if (child.type === "NORMAL") {
              astChildren.push(_expr2);
            }
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }

        createElementArguments.push.apply(createElementArguments, astChildren);
      }
      // cast to any for createElementArguments as casting it to BabelNodeExpresion[] isn't working
      var createElementCall = t.callExpression(createElementIdentifier, createElementArguments);
      this._addBailOutMessageToBabelNode(val, createElementCall);
      return createElementCall;
    }
  }, {
    key: "_serializeReactElementToJSXElement",
    value: function _serializeReactElementToJSXElement(val, reactElement) {
      var type = reactElement.type,
          attributes = reactElement.attributes,
          children = reactElement.children;


      var jsxTypeIdentifer = (0, _jsx.convertExpressionToJSXIdentifier)(type, true);
      var astAttributes = [];
      var _iteratorNormalCompletion4 = true;
      var _didIteratorError4 = false;
      var _iteratorError4 = undefined;

      try {
        for (var _iterator4 = attributes[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
          var attribute = _step4.value;

          var _expr3 = attribute.expr;

          if (attribute.type === "SPREAD") {
            astAttributes.push(t.jSXSpreadAttribute(_expr3));
          } else if (attribute.type === "PROPERTY") {
            var attributeKey = attribute.key;
            (0, _invariant2.default)(typeof attributeKey === "string");
            astAttributes.push((0, _jsx.convertKeyValueToJSXAttribute)(attributeKey, _expr3));
          }
        }
      } catch (err) {
        _didIteratorError4 = true;
        _iteratorError4 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion4 && _iterator4.return) {
            _iterator4.return();
          }
        } finally {
          if (_didIteratorError4) {
            throw _iteratorError4;
          }
        }
      }

      var astChildren = [];
      var _iteratorNormalCompletion5 = true;
      var _didIteratorError5 = false;
      var _iteratorError5 = undefined;

      try {
        for (var _iterator5 = children[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
          var child = _step5.value;

          var _expr4 = child.expr;

          if (child.type === "NORMAL") {
            if (t.isStringLiteral(_expr4) || t.isNumericLiteral(_expr4)) {
              astChildren.push(t.jSXText(_expr4.value + ""));
            } else if (t.isJSXElement(_expr4)) {
              astChildren.push(_expr4);
            } else {
              astChildren.push(t.jSXExpressionContainer(_expr4));
            }
          }
        }
      } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion5 && _iterator5.return) {
            _iterator5.return();
          }
        } finally {
          if (_didIteratorError5) {
            throw _iteratorError5;
          }
        }
      }

      var openingElement = t.jSXOpeningElement(jsxTypeIdentifer, astAttributes, astChildren.length === 0);
      var closingElement = t.jSXClosingElement(jsxTypeIdentifer);
      var jsxElement = t.jSXElement(openingElement, closingElement, astChildren, astChildren.length === 0);
      this._addBailOutMessageToBabelNode(val, jsxElement);
      return jsxElement;
    }
  }, {
    key: "_addBailOutMessageToBabelNode",
    value: function _addBailOutMessageToBabelNode(val, node) {
      // if there has been a bail-out, we create an inline BlockComment node before the JSX element
      if (val.$BailOutReason !== undefined) {
        // $BailOutReason contains an optional string of what to print out in the comment
        node.leadingComments = [{ type: "BlockComment", value: "" + val.$BailOutReason }];
      }
    }
  }, {
    key: "_serializeReactElementChild",
    value: function _serializeReactElementChild(child, reactElement) {
      var _this5 = this;

      var reactElementChild = this._createReactElementChild();
      this._serializeNowOrAfterWaitingForDependencies(child, reactElement, function () {
        var expr = _this5.residualHeapSerializer.serializeValue(child);

        reactElementChild.expr = expr;
        reactElementChild.type = "NORMAL";
      });
      return reactElementChild;
    }
  }, {
    key: "serializeLazyHoistedNodes",
    value: function serializeLazyHoistedNodes() {
      var entries = [];
      if (this._lazilyHoistedNodes !== undefined) {
        var _lazilyHoistedNodes = this._lazilyHoistedNodes,
            id = _lazilyHoistedNodes.id,
            nodes = _lazilyHoistedNodes.nodes,
            createElementIdentifier = _lazilyHoistedNodes.createElementIdentifier;
        // create a function that initializes all the hoisted nodes

        var func = t.functionExpression(null,
        // use createElementIdentifier if it's not null
        createElementIdentifier ? [createElementIdentifier] : [], t.blockStatement(nodes.map(function (node) {
          return t.expressionStatement(t.assignmentExpression("=", node.id, node.astNode));
        })));
        // push it to the mainBody of the module
        entries.push(t.variableDeclaration("var", [t.variableDeclarator(id, func)]));
        // output all the empty variable declarations that will hold the nodes lazily
        entries.push.apply(entries, _toConsumableArray(nodes.map(function (node) {
          return t.variableDeclaration("var", [t.variableDeclarator(node.id)]);
        })));
        // reset the _lazilyHoistedNodes so other additional functions work
        this._lazilyHoistedNodes = undefined;
      }
      return entries;
    }
  }]);

  return ResidualReactElementSerializer;
}();
//# sourceMappingURL=ResidualReactElementSerializer.js.map